//Connection:                                                                               filters+.
//Login:  branches. snapshots. LOCALFILTERS. WARNINGS. refresher.
//Branch:           snapshots. LOCALFILTERS. WARNINGS.
//snapshot:                    LOCALFILTERS. WARNINGS.
//renderer:                                      code.
//warning:                                   warncard.
//location:                                      code.
//filters:                                   WARNINGS.
//
//(file tree. warnfilters.) == LOCALFILTERS
//(warnlist. warncard. code.) == WARNINGS
SVACE_CLEANUP_LOGOUT = 0;   
SVACE_CLEANUP_LOGIN = 1;   // branches. snapshots. LOCALFILTERS. WARNINGS. refresher.; note that branches will be reloaded on whoami.
SVACE_CLEANUP_PROJECT = 22;
SVACE_CLEANUP_SNAPSHOT = 3;//                      LOCALFILTERS. WARNINGS.
SVACE_CLEANUP_RENDERER = 4;//                                        code.
SVACE_CLEANUP_WARNING = 5; //                                    warncard.
SVACE_CLEANUP_LOCATION = 6;//                                        code.
SVACE_CLEANUP_FILTERS = 7; //                                    WARNINGS
SVACE_CLEANUP_SWITCHPROJECTGROUP = 8;
SVACE_CLEANUP_COMPARE = 10;
SVACE_CLEANUP_COMPARE_BRANCH = 11;

function drop(what) {
	switch (what) {
	case SVACE_CLEANUP_LOGOUT:
		if (timeout!=null)
			clearTimeout(timeout);
		loadSource(null, null, null);
		$('.qtip').qtip('hide');
		$('#historyEntries').dialog("close");
		$("#projectSelectionForm").dialog("close");
		$('#managementForm').dialog("close");
		$('#settingsForm').dialog("close");
		$('#usagesForm').dialog("close");
		pushCardChanges();
		
		currentSvaceProject = null;
		LFAcontroller = null;
		COMPARE_PROJECTS={project_1: null,project_2: null}
		
		break;
	case SVACE_CLEANUP_COMPARE:
		stopCompareMod();
		makeBranchController(null, $("#compareUserBranch"), null, $("#compareUserBuild"), null);
		compareController = null;
		break;
	case SVACE_CLEANUP_LOGIN:
		if (!fetchAttributesValues()){
			setError("Svace failed to obtain warnings fields boundaries");
		};
	case SVACE_CLEANUP_PROJECT:
		WarningObjectsWrap.WarningObjects={};
		makeBranchController(null, $("#branchContainer"), null, $("#userBuild"), null);
		drop(SVACE_CLEANUP_COMPARE);
		//TODO: NEWSERVER: stop fetching updates when project selection window is open: we cannot return to already displayed results anyway
		//FIXME: fall through
    case SVACE_CLEANUP_SNAPSHOT:
    	$('#fileFilters').html("");
    	$('#attributeFilters').show();
    	toggleMenuElem(null);
    	svaceWarningsFilters = new Object();
    	svaceWarningsFilters._stub='%';
    	lastTreeBuild=undefined;
		//FIXME: fall through
	case SVACE_CLEANUP_FILTERS:
		displayWarning(null, null);
		gotWarnings = false;
		updatingAllProjects = false;
		gotWarningsFromAllProjects = false;
		fetching = false;
		loadSource(null, null, null);
		$('.qtip').qtip('hide');
		$('#historyEntries').dialog("close");
		clearDisplayedWarnings();
		break;
	case SVACE_CLEANUP_RENDERER:
		loadSource(lastLocation, lastProject, lastBuild, true);
	    	break;
	    case SVACE_CLEANUP_WARNING:
//	    	displayWarning(null);
//	    case SVACE_CLEANUP_LOCATION:
	    	break;
	    case SVACE_CLEANUP_SWITCHPROJECTGROUP:
			loadFromAllProjects = false;
			drop(SVACE_CLEANUP_PROJECT);
	    	break;
		default:
			setError("Internal error: unknown cleanup type: "+what);
	}
}
