var loginFormShown=false;

function forceLogin(message) {
	if (loginFormShown)
		return;
	drop(SVACE_CLEANUP_LOGOUT);
	loginFormShown=true;
	if (message==null) {
		message = "Login required!";
	};
	$('#loginForm').dialog("option", "title", message );
	$('#loginForm').dialog("open");
	$('#svaceLogin').focus();
}

function processLogin() {
	$('#loginStatus').text("Veryfying login data...");
	var pass = $('#svacePass').val();
	var OK = false;
	$.ajax( {
		url:'/history/api?act=auth',
		dataType: 'json',
		type: 'POST',
		data: 'user='+$('#svaceLogin').val()+'&key='+$('#svacePass').val(),
		async: false,
		cache: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status != "OK") {
				setError("Error:"+data.error);
			} else {
				OK = true;
				console.log("Logged in to a Svace web server");
//			$('#userName').text($('#svaceLogin').val());
			}
		},
		error: ajaxError
	});
	$('#loginStatus').text("");

	if (OK) {
		drop(SVACE_CLEANUP_LOGIN);
		$('#svacePass').val("");
		$('#loginForm').dialog( "close" );
		loginFormShown=false;
		showProjectSelectionDialog();
	}
}

function isLoggedIn() {
	var loggedIN = false;
	$.ajax( {
		url:'/history/api?act=whoami',
		dataType: 'json',
		type: 'GET',
		async: false,
		cache: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status != "OK") {
				setError("Error:"+data.error);
			} else {
				$('#userName').text(data.user);
				loggedIN = true;
			}
		},
		error: ajaxError
	});
	if (!loggedIN)
		return false;
	
	return true;
}

function fetchBranchesAndSnapshots() {
	if (COMPARE_MODE){
		//snapshots already set in selection dialog
		updateWarnings();
		return;
	} else if (loadFromAllProjects) {
		fetchBranchesLFA(); //this will fetch list of branches,
    	//choose default one and load warnings from it
	} else {
		if (currentSvaceProject.ui==null)
			currentSvaceProject.ui={};

		currentSvaceProject.ui.controller = makeBranchController(currentSvaceProject, $("#branchContainer"), null, $("#userBuild"), function(){
			if(compareMod)
				stopCompareMod();
			drop(SVACE_CLEANUP_SNAPSHOT);
			updateWarnings();
		});
		
		compareController = makeBranchController(currentSvaceProject, $("#compareUserBranch"), null, $("#compareUserBuild"), null);
	}
}

function logOut() {
	$.ajax( {
		url:'/history/api?act=close',
		dataType: 'json',
		async: false,
		cache: false,
		error: function (data, textstatus, error) {
			//we ignore such error cause it may be problem like "no session"
			//any connectivity problems will be detected in "obtain session"
		}
	});
	forceLogin();
	setError("");
}

function obtainSessionID() {
	var result="";
	var OK = false;
	logOut();
	$('#loginStatus').text("Initializing session...");
	var loginData = null;
	$.ajax( {
		url:'/history/api?act=init',
		dataType: 'json',
		async: false,
		cache: false,
		success: function (data, textStatus) {
			//data is already json
			if (data.status == "OK") {
				OK = true;
				loginData = new Object();
				loginData.ssalt = data.ssalt;
				loginData.rsalt = data.rsalt;
			}
		},
		error: ajaxError
	});
	return loginData;
}

